#!/usr/bin/perl
##############################################
#     WebFX Dynamic Discussion Board 2.0     #
#       By Emil A Eklund (eae@eae.net)       #
#      and Erik Arvidson (erik@eae.net)      #
#              April 24, 1999                #
##############################################
# Feel free to use this script for personal  #
# and non-profit organisation's websites,    #
# as long as you're giving us credits for it #
# in other words, not removing nur modifying #
# this notice in any of the files it apperes #
##############################################
#   For comercial use contact Emil or Erik   #
##############################################


##############################################
# Configuration

$datafile  = 'admin/data';                                      # Database
$title     = 'WebFX Dynamic Webboard';                          # Title of application
$errorlog  = 'admin/error.log';                                 # path to error log
$meurl     = 'http://webfx.eae.net/webboard/index.cgi';         # Url to this file
$referer   = 'http://webfx.eae.net/webboard/editMessage.html';  # Referer for dhtml version

# Done
##############################################

&ParseInput;
&GetAgent;
&DisplayHeader;
&GetCfg;
&GetData;

sub ParseInput {
  $input_method = $ENV{'REQUEST_METHOD'};
  if ($input_method eq 'GET') { $input = $ENV{QUERY_STRING}; }
  elsif ($input_method eq 'POST') { read(STDIN, $input, $ENV{CONTENT_LENGTH}); }
  @input_pairs = split /\&/ , $input;
  foreach $pair (@input_pairs) {
    if($pair=~m/([^=]+)=(.*)/) {
      $field = $1;
      $value = $2;
      $value =~ s/\+/ /g;
      $value =~ s/%([\dA-Fa-f]{2})/pack("C", hex($1))/eg;
      $in{$field} = $value;
    }
  }
}

sub GetAgent {
  @agentT = split(/\//,$ENV{'HTTP_USER_AGENT'});
  @agentver = split(/ /, $agentT[1]);
  $agentversion = substr($agentver[0], 0, 3);
  ($junk,$ie,$junk) = split(/\;/, $agentT[1]); ($junk,$junk,$ieversion) = split(/ /, $ie);
  if ($agentT[1] =~ /MSIE/ && $agentversion >= 4.0) { $dhtml = 1; }
}

sub DisplayHeader {
  print qq|Content-type:text/html\n\n|;
  print qq|<\!--\n|;
  print qq|##############################################\n|;
  print qq|#     WebFX Dynamic Discussion Board 2.0     #\n|;
  print qq|#       By Emil A Eklund (eae\@eae.net)       #\n|;
  print qq|#      and Erik Arvidson (erik\@eae.net)      #\n|;
  print qq|#              April 24, 1999                #\n|;
  print qq|##############################################\n|;
  print qq|# Feel free to use this script for personal  #\n|;
  print qq|# and non-profit organisation's websites,    #\n|;
  print qq|# as long as you're giving us credits for it #\n|;
  print qq|# in other words, not removing nur modifying #\n|;
  print qq|# this notice in any of the files it apperes #\n|;
  print qq|##############################################\n|;
  print qq|#   For comercial use contact Emil or Erik   #\n|;
  print qq|##############################################\n|;
  print qq|\/\/-->\n\n\n|;
}

sub GetDate {
  @months = ('January','Feburary','March','April','May','June','July','August','September','October','November','December');
  @days = ('Sunday','Monday','Tuesday','Wednesday','Thursday','Friday','Saturday');
  ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = gmtime($_[0]);
  ($Tsec,$Tmin,$Thour,$Tmday,$Tmon,$Tyear,$Twday,$Tyday,$isdst) = gmtime(time);
  $year = $year + 1900; $Tyear = $Tyear + 1900;
  $date = "$months[$mon] $mday, $year";
  if ($hour < 10) { $hour = "0$hour"; }
  if ($min < 10) { $min = "0$min"; }
  if ($sec < 10) { $sec = "0$sec"; }
  $time = "$hour:$min:$sec";
  $Cyday = $Tyday - $yday;
  if ($year == $Tyear) {
    $Cyday = $Tyday - $yday;
    $Cwday = $Twday - $wday;
    if ($Cyday == 0) { $date = "Today"; }
    elsif ($Cyday == 1) { $date = "Yesterday"; }
    elsif ($Cyday <= 7) { $date = "$days[$wday]"; }
  }
  return $date;
}

sub CheckReferer {
  $cReferer = "$ENV{'HTTP_REFERER'}";
  ($refererFile,$refererAction) = split(/\?/,$cReferer);
  if (($refererFile ne $referer && $dhtml) && ($refererFile ne $meurl && $dhtml == 0)) { &DisplayError('Invalid Referer'); }
}

sub GetCfg {
  open(DF,"$group");
  @database = <DF>;
  close(DF);
  $num = $database[0];
  chop($num);
  open(DF,"$datafile");
  @database = <DF>;
  close(DF);
  $password = $database[0];
  chop($password);
}

sub WriteCfg {
  open(DF,"$group");
  @database = <DF>;
  close(DF);
  $num++;
  $database[0] = "$num\n";
  open(DF,">$group");
  foreach $line (@database) {
    print DF "$line";
  }
  close(DF);
}

sub GetData {
  &GetInput;
  if ($action eq 'display' && $dhtml == 1) { &DisplayIndex; }
  elsif ($action eq 'groups') { &DisplayGroups; }
  elsif ($action eq 'tree') { &DisplayTree; }
  elsif ($action eq 'admintree') { &DisplayTree; }
  elsif ($action eq 'display' || $action eq 'preview') { &DisplayMsg; }
  elsif ($action eq 'post') { &DisplayPost; }
  elsif ($action eq 'new' || $action eq 'reply' || $action eq 'edit') { &WriteNew; }
  elsif ($action eq 'delete') { &Delete; }
  elsif ($action eq 'admin') { &DisplayIndex; }
  elsif ($action eq '') { &DisplayIndex; }
  elsif ($action eq 'newgroup') { &NewGroup; }
  elsif ($action eq 'updategroup') { &UpdateGroup; }
  elsif ($action eq 'removegroup') { &RemoveGroup; }
  elsif ($action eq 'updatepassword') { &UpdatePwd; }
  elsif ($action eq 'loadselect') { &LoadSelect; }
  elsif ($action eq 'error') { &LogError; }
  else { &DisplayError('Invalid Action'); }
}

sub LogError {
  &GetInput;
  open(EF,">>$errorlog");
  $time = time;
  print EF qq|$time\|:\|$ENV{'REMOTE_HOST'}\|:\|$ENV{'HTTP_REFERER'}\|:\|$ENV{'HTTP_USER_AGENT'}\|:\|$ENV{'QUERY_STRING_UNESCAPED'}\|:\|$url\|:\|$line\|:\|$error\n|;
  close(EF);
  print qq|<html>\n|;
  print qq|<script>\nalert("Error Logged!\\n Thank you for helping us find the bugs.");\n</script>\n|;
  print qq|</html>\n|;
  die;
}

sub DisplayIndex {
  &GetInput;
  open(DF,"$datafile");
  @database = <DF>;
  close(DF);
  ($group,$name,$text,$icon) = split(/\|:\|/,$database[1]);
  if ($action eq 'admin' && $pwd ne $password) { &DisplayError('Invalid Password'); }
  if ($action eq 'admin' && $dhtml == 0) { &DisplayError('MSIE Required for Admin Mode'); }
  if ($action eq 'admin') { $display = "admintree&pwd=$pwd"; $toolbar = 'adminToolBar.html'; }
  else { $display = 'tree'; $toolbar = 'toolBar.html'; }
  print qq|<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0//EN"\n"http://www.w3.org/TR/REC-html40/strict.dtd">\n|;
  if ($dhtml) {
    print qq|<HTML>\n<HEAD>\n<TITLE>$title (DHTML version)</TITLE>\n|;
    print qq|<script type="text/javascript" src="js/webboard.js"></script>\n\n|;
    print qq|<frameset rows="33,*" style="border: 0;" framespacing="0">\n|;
    print qq|  <frame name="toolframe" src="$toolbar" marginwidth="0" marginheight="0" scrolling="no" frameborder="no" noresize>\n|;
    print qq|  <frameset id="oeBarLayout" rows="*" cols="100,*" framespacing="3">\n|;
#    print qq|    <frameset rows="*,25" cols="*" framespacing="3">\n|;
#    print qq|      <frame name="oeBar" src="index.cgi?action=groups" scrolling="no" frameboarder="yes">\n|;
#    print qq|      <frame name="lowerOeBar" src="lowerOeBar.html" scrolling="no" frameboarder="yes">\n|;
#    print qq|    </frameset>\n|;
        print qq|    <frame name="oeBar" src="index.cgi?action=groups" scrolling="no" frameboarder="yes">\n|;
    print qq|    <frameset id="layout" rows="30%, *" cols="*" border="5" framespacing="3">\n|;
    print qq|      <frame name="treeframe" src="index.cgi?action=$display&group=$group" scrolling="No" frameborder="yes">\n|;
    print qq|      <frame name="messageframe" src="messageViewer.html" scrolling="auto" frameborder="no">\n|;
    print qq|    </frameset>\n|;
    print qq|  </frameset>\n|;
    print qq|</frameset>\n|;
    print qq|</HTML>\n|;
  }
  else { &DisplayTree; }
}

sub GetInput {
  $action = "$in{'action'}";
  $subject = "$in{'subject'}"; $subject =~ s/\&/\&amp\;/g; $subject =~ s/</\&lt\;/g; $subject =~ s/>/\&gt\;/g; $subject =~ s/\|/\&#124\;/g;
  $from = "$in{'name'}"; $from =~ s/\&/\&amp\;/g; $from =~ s/</\&lt\;/g; $from =~ s/>/\&gt\;/g; $from =~ s/\|/\&#124\;/g;
  $email = "$in{'email'}"; $email =~ s/\&/\&amp\;/g; $email =~ s/</\&lt\;/g; $email=~ s/>/\&gt\;/g; $email =~ s/\|/\&#124\;/g;
  $txt = "$in{'body'}"; $txt =~ s/\|/\&#124\;/g; if ($dhtml == 1) { $txt =~ s/\cM\n/ /g; }
  $group = "$in{'group'}"; $group =~ s/\&/\&amp\;/g; $group =~ s/</\&lt\;/g; $group =~ s/>/\&gt\;/g; $group =~ s/\|/\&#124\;/g;
  $id = "$in{'id'}"; $id =~ s/\&/\&amp\;/g; $id =~ s/</\&lt\;/g; $id =~ s/>/\&gt\;/g; $id =~ s/\|/\&#124\;/g;
  $pwd = "$in{'pwd'}"; $pwd =~ s/\&/\&amp\;/g; $pwd =~ s/</\&lt\;/g; $pwd =~ s/>/\&gt\;/g; $pwd =~ s/\|/\&#124\;/g;
  $name = "$in{'name'}"; $name =~ s/\&/\&amp\;/g; $name =~ s/</\&lt\;/g; $name =~ s/>/\&gt\;/g; $name =~ s/\|/\&#124\;/g;
  $text = "$in{'description'}"; $text =~ s/\&/\&amp\;/g; $text =~ s/</\&lt\;/g; $text =~ s/>/\&gt\;/g; $text =~ s/\|/\&#124\;/g;
  $icon = "$in{'image'}"; $icon =~ s/\&/\&amp\;/g; $icon =~ s/</\&lt\;/g; $icon =~ s/>/\&gt\;/g; $icon =~ s/\|/\&#124\;/g;
  $old = "$in{'old'}"; $old =~ s/\&/\&amp\;/g; $old =~ s/</\&lt\;/g; $old =~ s/>/\&gt\;/g; $old =~ s/\|/\&#124\;/g;
  $new1 = "$in{'new1'}"; $new1 =~ s/\&/\&amp\;/g; $new1 =~ s/</\&lt\;/g; $new1 =~ s/>/\&gt\;/g; $new1 =~ s/\|/\&#124\;/g;
  $new2 = "$in{'new2'}"; $new2 =~ s/\&/\&amp\;/g; $new2 =~ s/</\&lt\;/g; $new2 =~ s/>/\&gt\;/g; $new2 =~ s/\|/\&#124\;/g;
  $url  = "$in{'url'}"; $url =~ s/\|/\&#124\;/g;
  $line = "$in{'line'}"; $line =~ s/\|/\&#124\;/g;
  $error = "$in{'error'}"; $error =~ s/\|/\&#124\;/g;
}

sub DisplayGroups {
  print qq|<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0//EN"\n"http://www.w3.org/TR/REC-html40/strict.dtd">\n|;
  print qq|<HTML>\n<HEAD>\n<TITLE>$title</TITLE>\n|;
  print qq|<link rel="STYLESHEET" type="text/css" href="webboard.css">\n|;
  print qq|<script type="text/javascript" src="js/webboard.js"></script>\n|;
  print qq|<script type="text/javascript">\n|;
  print qq|initOeBar()\n|;
  print qq|</script>\n|;
  print qq|</head>\n|;
  print qq|<body class="oeBar" scroll="no">\n|;
  print qq|<div style=""id="oeBarContainer" upButton="UpButton" downbutton="DownButton">\n|;
  open(DF,"$datafile");
  @database = <DF>;
  close(DF);
  foreach $line (@database) {
    chop($line);
    ($group,$name,$text,$icon) = split(/\|:\|/,$line);
    if ($name ne '') {
      print qq|<div class="oeBarButton" title="$text" onclick="loadTree('$group')">\n|;
      print qq|<img src="$icon"><br>\n|;
      print qq|$name\n|;
      print qq|</div>\n|;
    }
  }
  print qq|</div>\n|;
  print qq|<div class="scrollButton" id="UpButton" type="up" for="oeBarContainer">5</div>\n|;
  print qq|<div class="scrollButton" id="DownButton" type="down" for="oeBarContainer">6</div>\n|;
  print qq|</body>\n</html>\n|;
}

sub DisplayTree {
  if ($action eq '' && $group eq '') { &GetInput; }
  if ($action eq 'admintree' && $pwd ne $password) { &DisplayError('Invalid Password'); }
  $rtree = "$in{'rtree'}"; if ($rtree eq '') { $rtree = 1; }
  if ($rtree == 0) { $rtree2 = 1; }
  else { $rtree2 = 0; }
  if ($dhtml) {
    print qq|<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0//EN"\n"http://www.w3.org/TR/REC-html40/strict.dtd">\n|;
    print qq|<HTML>\n<HEAD>\n<TITLE>$title</TITLE>\n|;
    print qq|<link rel="STYLESHEET" type="text/css" href="webboard.css">\n|;
    print qq|<base target="messageframe">\n|;
    print qq|<script type="text/javascript" src="js/webboard.js"></script>\n\n|;
    if ($action eq 'admintree') { print qq|</HEAD>\n<BODY scroll="no" onselectstart="return false" class="messageTreeBody" password="$pwd" group="$group">\n\n|; }
    else { print qq|</HEAD>\n<BODY scroll="no" onselectstart="return false" class="messageTreeBody" group="$group">\n\n|; }
    print qq|<table class="headerTable" cellspacing="1" cellpadding="0" id="messageHeader">\n|;
    print qq|  <tr>\n|;
    print qq|    <td id="subjectHeader" onclick="sortBy('subject')">Subject</td>\n|;
    print qq|    <td id="fromHeader" onclick="sortBy('from')">From</td>\n|;
    if ($ieversion >= 5.0) { print qq|    <td id="sentHeader" onclick="sortBy('sent')">Sent<span class="arrow" id="startArrow">5</span></td>\n|; }
    else { print qq|    <td id="sentHeader" style="cursor: hand;" onClick="window.location='index.cgi?action=tree&group=$group&rtree=$rtree'" title="Reload tree in reversed sent order">Sent<span class="arrow" id="startArrow">5</span></td>\n|; }
    print qq|    <td>&nbsp;</td>\n|;
    print qq|  </tr>\n|;
    print qq|</table>\n\n|;
    print qq|<div id="scrollDiv">\n|;
    print qq|<script>\n|;
    print qq|   initMessageTree();\n|;
    print qq|</script>\n|;
    print qq|<div class="treeView" id="messageTree">\n|;
    print qq|<nobr>\n\n|;
    open(DF,"$group");
    @database = <DF>;
    close(DF);
    if ($rtree) { &ReverseTree; }
    print "<div>\n";
    $oldlevel = 0;
    foreach $line (@database) {
      ($level,$id,$subject,$from,$email,$sent,$txt) = split(/\|:\|/,$line);
      $date = GetDate($sent);
      if ($id ne '') {
        if ($level < $oldlevel) {
          $lvl = $oldlevel - $level;
          while ($lvl > 0) {
            print "</div>\n";
            $lvl--;
          }
        }
        if ($level <= $oldlevel) { print "</div>\n"; }
        $oldlevel = $level;
        if ($action eq 'admintree') { print qq|<div class="item" date="$sent"><span class="plus"></span><input type="Checkbox"><a href="?action=preview&group=$group&id=$id" email="$email"><span class="subject"><img class="icon" src="images/message2.gif" align="absmiddle">$subject</span><span class="name">$from</span><span class="date">$date</span></a><br>\n|; }
        else { print qq|<div class="item" date="$sent"><span class="plus"></span><a href="?action=preview&group=$group&id=$id" email="$email"><span class="subject"><img class="icon" src="images/message2.gif" align="absmiddle">$subject</span><span class="name">$from</span><span class="date">$date</span></a><br>\n|; }
      }
    }
    while ($oldlevel > -1) {
      print "</div>\n";
      $oldlevel--;
    }
    print qq|</nobr></div></div>\n\n</body>\n</html>\n|;
  }
  else {
    print qq|<HTML><HEAD><TITLE>$title (Static Version)</TITLE></HEAD>\n|;
    print qq|<BODY background="images/treeback.gif" link="navy" bgcolor="White" text="Black" vlink="Black" alink="Black" leftmargin="5" topmargin="5" marginwidth="5" marginheight="5">\n|;
    print qq|<table border="0" cellspacing="0" cellpadding="0" nowrap><form action="index.cgi" method="get"><input type="hidden" name="action" value="tree">\n|;
    print qq|<tr><td colspan="3"><nobr><FONT face="Arial Black" size="7"><EM><FONT color=navy>W</FONT>ebFX <FONT\n|;
    print qq|color=#000080>W</FONT>ebBoard</EM></FONT></nobr></td></tr><tr><td colspan="3" align="center">\n|;
    print qq|<font face="Ms Sans Serif" size="1" color="Black">You have reached the backward compatible version of WebFX Dynamic Webboard.<br> Here is a <a>screen shot</a> of how it looks in <a href="images/webboard.gif">Internet Explorer</a>.</font>\n|;
    print qq|</td></tr><tr><td colspan="3"><hr width="460" align="left"></td></tr><tr><td>\n|;
    print qq|<a href="index.cgi?action=post&group=$group"><img src="images/newMessageOld.gif" width=129 height=20 border=0 alt="New Message"></a>\n</td><td><select name="group" size="1">\n|;
    open(DF,"$datafile");
    @database = <DF>;
    close(DF);
    foreach $line (@database) {
      chop($line);
      ($Tgroup,$Tname,$Ttext,$Ticon) = split(/\|:\|/,$line);
      if ($Tname ne '') {
        if ($Tgroup eq $group) { print qq|  <option selected value="$Tgroup">$Tname</option>\n|; }
        else { print qq|  <option value="$Tgroup">$Tname</option>\n|; }
      }
    }
    print qq|</select>&nbsp;<input type="image" src="images/gobutton.gif" width="31" height="20" border="0">\n</td></form><td align="RIGHT">\n|;
    print qq|<font face="Helvetica, Arial, Verdana" size="2" color="Black">Back to <a href="http://webfx.eae.net"><b>WebFX</b></a></font>\n|;
    print qq|</td></tr><tr><td colspan="3">\n|;
    print qq|<hr width="460" align="left">\n|;
    print qq|</td></tr></table>\n|;
    print qq|<font face="Arial, Helvetica" size="-1" color="Black">\n<nobr>\n|;
    open(DF,"$group");
    @database = <DF>;
    close(DF);
    if ($rtree) { &ReverseTree; }
    foreach $line (@database) {
      ($level,$id,$subject,$from,$email,$sent,$txt) = split(/\|:\|/,$line);
      $date = GetDate($sent);
      if ($id ne '') {
        $lvl = "\&nbsp\;";
        while ($level > 0) {
          $lvl = "$lvl\&nbsp\;\&nbsp\;\&nbsp\;\&nbsp\;";
          $level--;
        }
        print qq|$lvl<a href="?action=display&id=$id&group=$group"><b><img src="images/message2.gif" align="absmiddle" border="0">$subject</b></a>, $from, $date\n|;
        print qq|<img src="images/spacer.gif" width="1" height="18"><br>\n|;
      }
    }
    print qq|</nobr></font>\n\n|;
    print qq|<table border="0" cellspacing="0" cellpadding="0" nowrap>\n|;
    print qq|<tr><td colspan="2">\n|;
    print qq|<hr width="460" align="left">\n|;
    print qq|</td></tr>|;
    print qq|<tr><td align="left">\n|;
    print qq|<font face="Helvetica, Arial, Verdana" size="2" color="Black"><a href="index.cgi?action=tree&group=$group&rtree=$rtree2"><b>Reverse Tree</b></a></font>\n|;
    print qq|</td><td align="right">\n|;
    print qq|<font face="Helvetica, Arial, Verdana" size="2" color="Black">Back to <a href="http://webfx.eae.net"><b>WebFX</b></a></font>\n|;
    print qq|</td></tr>\n|;
    print qq|</table>\n|;
    print qq|</body>\n</html>\n|;
  }
}

sub ReverseTree {
  @database2 = reverse @database;
  @database3 = @database;
  undef @database;
  $num = 0;
  foreach $line (@database2) {
    ($level,$id,$subject,$junk) = split(/\|:\|/,$line);
    if ($level == 0 && id ne '') {
      @database[$num] = $line;
      $num++; $start = 0;
      foreach $line (@database3) {
        ($level,$id2,$subject,$junk) = split(/\|:\|/,$line);
        if ($level == 0 && $start) { last; }
        elsif ($id2 eq $id) { $start = 1; }
        elsif ($start) {
          @database[$num] = $line;
          $num++;
} } } } }

sub DisplayMsg {
  $inid = "$in{'id'}";
  if ($dhtml == 1) {
    open(DF,"$group");
    @database = <DF>;
    close(DF);
    foreach $line (@database) {
      ($level,$id,$subject,$from,$email,$sent,$txt) = split(/\|:\|/,$line);
      if ($id eq $inid) { last; }
    }
    print qq|$txt\n|;
  }
  else {
    print qq|<HTML><HEAD><TITLE>$title (Static Version)</TITLE></HEAD>\n|;
    print qq|<BODY background="images/treeback.gif" link="navy" bgcolor="White" text="Black" vlink="Black" alink="Black" leftmargin="10" topmargin="10" marginwidth="10" marginheight="10">\n|;
    print qq|<nobr><FONT face="Arial Black" size="7"><EM><FONT color=navy>W</FONT>ebFX <FONT color=#000080>W</FONT>ebBoard</EM></FONT></nobr><br>\n|;
    print qq|<table width="480"><tr>\n|;
    print qq|<td valign="bottom"><font face="Helvetica, Arial, Verdana" size="2" color="Black"><b>Message Thread:</b><br></font></td>\n|;
    print qq|<td align="RIGHT" valign="bottom"><FONT face="Helvetica, Arial, Verdana" size="2">View <a href=""><b>All Messages</b></a></br>Back to <a href="http://webfx.eae.net"><b>WebFX</b></a></font></td>\n|;
    print qq|</tr></table>\n|;
    print qq|<font face="Helvetica, Arial, Verdana" size="2" color="Black">\n<nobr>\n|;
    open(DF,"$group");
    @database = <DF>;
    close(DF);
    $threadStartId = '';
    foreach $line (@database) {
      chop($line);
      ($level,$id,$subject,$from,$email,$sent,$txt) = split(/\|:\|/,$line);
      if ($id ne '') {
        if ($level == 0) { $threadStartId = $id; }
        if ($inid eq $id) { last; }
    } }
    $inThread = 0;
    foreach $line (@database) {
       ($level,$id,$subject,$from,$email,$sent,$txt) = split(/\|:\|/,$line);
       $date = GetDate($sent);
       if ($id eq $threadStartId) { $inThread = 1; }
       if ($level == 0 && $id ne $threadStartId && $inThread) { last;}
       if ($id ne '' && $inThread) {
          $lvl = "\&nbsp\;";
          while ($level > 0) {
             $lvl = "$lvl\&nbsp\;\&nbsp\;\&nbsp\;\&nbsp\;";
             $level--;
          }
          if ($id eq $inid) {
            print qq|$lvl<b><img src="images/message2.gif" align="absmiddle" border="0">$subject, $from, $date</b>\n|;
            print qq|<img src="images/spacer.gif" width="1" height="18"><br>\n|;
          }
          else {
            print qq|$lvl<a href="?action=display&id=$id&group=$group"><b><img src="images/message2.gif" align="absmiddle" border="0">$subject</b></a>, $from, $date\n|;
            print qq|<img src="images/spacer.gif" width="1" height="18"><br>\n|;
    } } }
    print qq|</nobr></font>\n<br>\n|;
    print qq|<FONT face="Helvetica, Arial, Verdana" size="2">\n|;
    foreach $line (@database) {
      ($level,$id,$subject,$from,$email,$sent,$txt) = split(/\|:\|/,$line);
      if ($id eq $inid) { last; }
    }
    $date = GetDate($sent);
    $bodyStartTagStart = index(lc($txt), "<body");
    $bodyStartTagEnd   = index($txt, ">", $bodyStartTagStart);
    $bodyEndTagStart = index(lc($txt), "</body", $bodyStartTagEnd);
    $txt = substr($txt, $bodyStartTagEnd + 1, $bodyEndTagStart - $bodyStartTagEnd - 1);
    print qq|<nobr>Subject: <b>$subject</b></nobr>\n|;
    print qq|<nobr>From: <a href="mailto:$email"><b>$from</b></a></nobr>\n|;
    print qq|<nobr>Date: <b>$date</b></FONT></nobr>\n|;
    print qq|<table width="480" border="1" cellspacing="0" cellpadding="5" bordercolor="#dddddd" bgcolor="white">\n|;
    print qq|<tr><td><FONT face="Helvetica, Arial, Verdana" size="2">\n$txt\n|;
    print qq|</font></td></tr></table><br><br><br>\n|;
    print qq|<form action="index.cgi" method="POST">\n|;
    print qq|<input type="hidden" name="action" value="reply">\n|;
    print qq|<input type="hidden" name="group" value="$group">\n|;
    print qq|<input type="hidden" name="id" value="$inid">\n|;
    print qq|<table width="480" border="0" cellspacing="0" cellpadding="0">\n|;
    print qq|<tr><td colspan="2">\n|;
    print qq|<FONT face="Arial Black" size="6"><EM><FONT color=navy>R</FONT>eply</FONT>\n|;
    print qq|</td></tr><tr><td><FONT face="Helvetica, Arial, Verdana" size="2"><b>Name:</b>&nbsp;</FONT></td>\n|;
    print qq|<td><input name="name" type="text" size="52"></td>\n|;
    print qq|</tr><tr><td><FONT face="Helvetica, Arial, Verdana" size="2"><b>Email:</b>&nbsp;</FONT></td>\n|;
    print qq|<td><input name="email" type="text" size="52"></td>\n|;
    print qq|</tr><tr><td><FONT face="Helvetica, Arial, Verdana" size="2"><b>Subject:</b>&nbsp;</FONT></td>\n|;
    print qq|<td><input name="subject" type="Text" size="52" value="|;
    if (index($subject, "Re:") > -1) { print qq|$subject|; }
    else { print qq|Re:$subject|; }
    print qq|"></td>\n|;
    print qq|</tr><tr><td colspan="2"><br>\n|;
    print qq|<FONT face="Helvetica, Arial, Verdana" size="2" color="Black">\n|;
    print qq|Enter your reply to this message below. HTML tags are not supported but words that start with <b>http://</b>, <b>ftp://</b> or <b>mailto:</b>\n|;
    print qq|are converted to links.</font></td>\n|;
    print qq|</tr><tr><td colspan="2">\n|;
    print qq|<textarea name="body" cols="57" rows="15">|;
    &FixTextForTextArea;
    print qq|$txt|;
    print qq|</textarea>\n|;
    print qq|</td></tr><tr>\n|;
    print qq|<td align="RIGHT" colspan="2">\n|;
    print qq|<input type="Image" value="submit" src="images/postMessageOld.gif" border="0" width="129" height="20" vspace="5" hspace="0"></td>\n|;
    print qq|</tr></table><br>\n|;
    print qq|<table width="480" border="0" cellspacing="0" cellpadding="0">\n|;
    print qq|<tr><td valign="top"><hr width="360"></td><td align="RIGHT">\n|;
    print qq|<FONT face="Helvetica, Arial, Verdana" size="2" color="Black">\n|;
    print qq|View <a href=""><b>All Messages</b></a></br>\n|;
    print qq|Back to <a href="http://webfx.eae.net"><b>WebFX</b></a></font></td>\n|;
    print qq|</tr></table></form>\n\n</body>\n</html>\n|;
  }
}

sub FixTextForTextArea {
  $txt =~ s/(<(br|BR)>)|<\/(p|P|div|DIV|h.|H.|pre|PRE|ul|UL|ol|OL)>/\n/g;
  $txt =~ s/\<.*?\>//gs;
}

sub DisplayPost {
  &GetInput;
  if ($dhtml) { &DisplayError('This Function is only used for the Static version'); }
  print qq|<HTML><HEAD><TITLE>$title (Static Version)</TITLE></HEAD>\n|;
  print qq|<BODY background="images/treeback.gif" link="navy" bgcolor="White" text="Black" vlink="Black" alink="Black" leftmargin="5" topmargin="5" marginwidth="5" marginheight="5">\n|;
  print qq|<table border="0" cellspacing="0" cellpadding="0" nowrap>\n|;
  print qq|<form action="index.cgi" method="POST">\n|;
  print qq|<input type="hidden" name="action" value="new">\n|;
  print qq|<input type="hidden" name="group" value="$group">\n|;
  print qq|<table width="480" border="0" cellspacing="0" cellpadding="0">\n|;
  print qq|<tr><td colspan="3">\n|;
  print qq|<FONT face="Arial Black" size="6"><EM><FONT color=navy>N</FONT>ew</FONT>\n|;
  print qq|</td></tr><tr><td><FONT face="Helvetica, Arial, Verdana" size="2"><b>Name:</b>&nbsp;</FONT></td>\n|;
  print qq|<td colspan="2"><input name="name" type="text" size="52"></td>\n|;
  print qq|</tr><tr><td><FONT face="Helvetica, Arial, Verdana" size="2"><b>Email:</b>&nbsp;</FONT></td>\n|;
  print qq|<td colspan="2"><input name="email" type="text" size="52"></td>\n|;
  print qq|</tr><tr><td><FONT face="Helvetica, Arial, Verdana" size="2"><b>Subject:</b>&nbsp;</FONT></td>\n|;
  print qq|<td colspan="2"><input name="subject" type="Text" size="52"></td>\n|;
  print qq|</tr><tr><td colspan="3"><br>\n|;
  print qq|<FONT face="Helvetica, Arial, Verdana" size="2" color="Black">\n|;
  print qq|Enter your reply to this message below. HTML tags are not supported but words that start with <b>http://</b>, <b>ftp://</b> or <b>mailto:</b>\n|;
  print qq|are converted to links.</font></td>\n|;
  print qq|</tr><tr><td colspan="3">\n|;
  print qq|<textarea name="body" cols="57" rows="15"></textarea>\n|;
  print qq|</td></tr><tr>\n|;
  print qq|<td colspan="2">&nbsp;</td>\n|;
  print qq|<td align="RIGHT">\n|;
  print qq|<input type="Image" value="submit" src="images/postMessageOld.gif" border="0" width="129" height="20" vspace="5" hspace="0"></td>\n|;
  print qq|</tr></table><br>\n|;
  print qq|<table width="480" border="0" cellspacing="0" cellpadding="0">\n|;
  print qq|<tr><td valign="top"><hr width="360"></td><td align="RIGHT">\n|;
  print qq|<FONT face="Helvetica, Arial, Verdana" size="2" color="Black">\n|;
  print qq|View <a href=""><b>All Messages</b></a></br>\n|;
  print qq|Back to <a href="http://webfx.eae.net"><b>WebFX</b></a></font></td>\n|;
  print qq|</tr></table></form>\n\n</body>\n</html>\n|;
}

sub WriteNew {
  &GetInput;
  &GetCfg;
  if ($pwd ne $password && $action eq 'edit') { &DisplayError('Invalid Password'); }
  if ($action eq 'new' || $action eq 'reply') { &CheckReferer; }
  if ($subject eq "") { &DisplayError('Empty Subject field'); }
  if ($from eq "") { &DisplayError('Empty From field'); }
  if ($txt eq "") { &DisplayError('Empty Text field'); }
  if ($dhtml == 0) {
#   $txt =~ s/(<(br|BR)>)|<\/(p|P|div|DIV|h.|H.|pre|PRE|ul|UL|ol|OL)>/\n/g;
#   $txt =~ s/\<.*?\>//gs;
    $txt =~ s/\&/\&amp\;/g;
    $txt =~ s/</\&lt\;/g;
    $txt =~ s/>/\&gt\;/g;
    $txt =~ s/(http\:\/\/.*?)(\s|$)/\<a href\=\"$1\"\>$1\<\/a\> /gi;
    $txt =~ s/(ftp\:\/\/.*?)(\s|$)/\<a href\=\"$1\"\>$1\<\/a\> /gi;
    $txt =~ s/(mailto\:.*?)(\s|$)/\<a href\=\"$1\"\>$1\<\/a\> /gi;
    $txt =~ s/(\cM\n|\n)/<br>/g;
    $txt = "<html><body><font size=2 face=\"courier new\">$txt</font></body></html>";
  }
  $inid = $in{'id'};
  $date = time;
  if ($inid ne '' && ($action eq 'reply' || $action eq 'edit' || $action eq 'delete')) {
    open(DF,"$group");
    @database = <DF>;
    close(DF);
    open(DF,">$group");
    foreach $line (@database) {
      ($level,$id,$junk) = split(/\|:\|/,$line);
      if ($id eq $inid) {
        if ($action eq 'reply') {
          print DF "$line";
          $lvl = $level + 1;
        }
        else { $lvl = $level; }
        print DF "$lvl\|:\|$num\|:\|$subject\|:\|$from\|:\|$email\|:\|$date\|:\|$txt\n";
      }
      else { print DF "$line"; }
  } }
  elsif ($action eq 'new') {
    open(DF,">>$group");
    print DF "0\|:\|$num\|:\|$subject\|:\|$from\|:\|$email\|:\|$date\|:\|$txt\n";
  }
  close(DF);
  &WriteCfg;
  if ($dhtml) {
    print qq|<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0//EN"\n"http://www.w3.org/TR/REC-html40/strict.dtd">\n|;
    print qq|<HTML>\n<HEAD>\n<TITLE>$title</TITLE>\n|;
    print qq|</head><body>\n|;
    print qq|Message Sent\n|;
    print qq|</body>\n|;
    print qq|<script>\n|;
    print qq|  window.close()\n|;
    print qq|</script>\n|;
    print qq|</html>\n|;
  }
  else { &DisplayIndex; }
}

sub Delete {
  &GetInput;
  if ($pwd ne $password) { &DisplayError('Invalid Password'); }
  @del = split(/\,/,$id);
  $num = 0;
  foreach $line (@del) {
    open(DF,"$group");
    @database = <DF>;
    close(DF);
    open(DF,">$group");
    foreach $line (@database) {
      ($level,$id,$junk) = split(/\|:\|/,$line);
      if ($id ne $del[$num]) { print DF "$line"; }
    }
    $num++;
  }
  $action = 'admintree';
  &DisplayTree;
}

sub NewGroup {
  &GetInput;
  if ($pwd ne $password) { &SendResponse("createNewGroupResponse","false",$group,$name,$text,$icon,"Invalid Password"); }
  open(DF,"$datafile");
  @database = <DF>;
  close(DF);
  foreach $line (@database) {
    chop($line);
    ($Tgroup,$Tname,$Ttext,$Ticon) = split(/\|:\|/,$line);
    if ($group eq $Tgroup) {
      &SendResponse("createNewGroupResponse","false",$group,$name,$text,$icon,"Group Alredy Exists");
  } }
  open(DF,">>$datafile");
  print DF qq|$group\|:\|$name\|:\|$text\|:\|$icon\n|;
  close(DF);
  open(NF, ">>$group");
  print NF "";
  close(NF);
  &SendResponse("createNewGroupResponse","true",$group,$name,$text,$icon,"No Error");
}

sub UpdateGroup {
  &GetInput;
  if ($pwd ne $password) { &SendResponse("updateGroupResponse","false",$group,$name,$text,$icon,"Invalid Password"); }
  open(DF,"$datafile");
  @database = <DF>;
  close(DF);
  $num = 0;
  $status = 0;
  foreach $line (@database) {
    chop($line);
    ($Tgroup,$Tname,$Ttext,$Ticon) = split(/\|:\|/,$line);
    if ($group eq $Tgroup) { $database[$num] = "$group|:|$name|:|$text|:|$icon\n"; $status = 1; }
    else { $database[$num] = $line; }
    $num++;
  }
  if ($status) {
    open(DF,">$datafile");
    foreach $line (@database) {
      print DF "$line\n";
    }
    close(DF);
    &SendResponse("updateGroupResponse","true",$group,$name,$text,$icon,"No Error");
  }
  else { &SendResponse("updateGroupResponse","false",$group,$name,$text,$icon,"Group Does Not Exist"); }
}

sub RemoveGroup {
  &GetInput;
  if ($pwd ne $password) { &SendResponse("removeGroupResponse","false","$group","Invalid Password"); }
  open(DF,"$datafile");
  @database = <DF>;
  close(DF);
  open(DF,">$datafile");
  foreach $line (@database) {
    chop($line);
    ($Tgroup,$junk) = split(/\|:\|/,$line);
    if ($Tgroup ne $group) { print DF "$line\n"; }
  }
  $Output = `rm -f $group`;
  &SendResponse("removeGroupResponse","true","$group","No Error");
}

sub UpdatePwd {
  &GetInput;
  if ($old ne $password) { &SendResponse("updatePasswordResponse","false","Invalid Old Password."); }
  if ($new1 ne $new2) { &SendResponse("updatePasswordResponse","false","You need to enter the same password twice."); }
  open(DF,"$datafile");
  @database = <DF>;
  close(DF);
  $database[0] = "$new1\n";
  open(DF,">$datafile");
  foreach $line (@database) {
    print DF "$line";
  }
  close(DF);
  &SendResponse("updatePasswordResponse","true");
}

sub LoadSelect {
  print qq|<html><head>\n<script>\n|;
  print qq|parent.loadSelect(true, new Array(|;
  open(DF,"$datafile");
  @database = <DF>;
  close(DF);
  $comma = '';
  foreach $line (@database) {
    chop($line);
    ($group,$name,$text,$icon) = split(/\|:\|/,$line);
    if ($name ne '') { print qq|$comma new Array("$group","$name","$text","$icon")|; $comma = ","; }
  }
  print qq|));\n|;
  print qq|</script>\n</head><body></body></html>|;
}

sub SendResponse {
  print qq|<html>\n<head>\n|;
  print qq|<script>\n|;
  print qq|  parent.$_[0]($_[1],"$_[2]","$_[3]","$_[4]","$_[5]","$_[6]")\n|;
  print qq|</script>\n|;
  print qq|</head>\n|;
  print qq|<body></body>\n|;
  print qq|</html>\n|;
  die;
}

sub DisplayError {
  print qq|<HTML>\n<HEAD>\n<TITLE>$title</TITLE>\n|;
  print qq|</HEAD><BODY>\n|;
  print qq|<center><h2>Error: $_[0]</h2></center>\n|;
  print qq|</BODY></HTML>\n|;
  die;
}