/*
##############################################
#         WebFX Dynamic Webboard 2.0         #
#       By Emil A Eklund (eae@eae.net)       #
#      and Erik Arvidson (erik@eae.net)      #
#           http://webfx.eae.net             #
#              April 13, 1999                #
##############################################
# Feel free to use this script for personal  #
# and non profit web sites, as long as you   #
# are giving us credits for it, in other     #
# words, not removing nor modifying this     #
# notice in any of the files it appears in   #
##############################################
#  For commercial use contact Emil or Erik   #
##############################################

This is for the actual tree
*/


document.onclick = handleClick;
window.onload = initMessageTreePrime;
window.onresize = fixSize;

document.onmouseover = messageTreeOnMouseOver;
document.onmouseout  = messageTreeOnMouseOut;
	
//preload(new Array("minusicon"), "images/", ".gif");

fixSubPadding(10);
fixScrollDivSize();

function fixSize() {
	messageHeader.style.width =  Math.max(document.body.clientWidth, 570);
    scrollDiv.style.height = Math.max(document.body.clientHeight - messageHeader.offsetHeight, 0);
}

var currentMessageAnchorObject;
var currentMessageTimer;

// This works in conjunction with the css file that marks visited links
function markAsRead() {
	if (currentMessageAnchorObject && currentMessageAnchorObject.style)
		currentMessageAnchorObject.style.fontWeight = "normal";
}

function handleClick() {
	var plusEl = getReal(window.event.srcElement, "className", "plus");
	if (plusEl.className == "plus" && plusEl.children.length > 0) {
		if (plusEl.children.tags("IMG")[0].src.indexOf("minus") != -1)
			hideItem(plusEl);
		else
			showItem(plusEl);
		return;
	}
	
	var el = getReal(window.event.srcElement, "tagName", "A");
	if (el.tagName == "A") {
		if (parent.messageframe.document && parent.messageframe.document.readyState == "complete") {
			if (document.body.selectedItem != el) { // First selection
				if (document.body.selectedItem != null)
					unHighLight(document.body.selectedItem);
				document.body.selectedItem = el;
				highLight(el);
			}

			makeMessageVisible(el.parentElement);
	
			var subject = el.children[0].innerHTML;
	
	
			var startIndex = subject.indexOf(">");
			var endIndex   = subject.indexOf("<", startIndex);
			if (endIndex == -1) endIndex = subject.length
			
			subject = subject.substring(startIndex+1, endIndex)
			var from = el.children[1].innerText;
			var date = el.children[2].innerText;
			var email = el.email;
			var group = document.body.group;
			var ticks = el.parentElement.date;
			parent.messageframe.loadMessage(el.href, subject, from, email, date, group, ticks);
			}
		else
			alert(waitForViewerError);
		
		return false;
	}
	
	var el = getReal(window.event.srcElement, "tagName", "INPUT");
	if (el.tagName == "INPUT") {
		addToIdList(el);
		markTree(el);
	}

}


function messageTreeOnMouseOver() {
	var fromEl = getReal(window.event.fromElement, "tagName", "A");
	var toEl = getReal(window.event.toElement, "tagName", "A");
    
    if (fromEl == toEl) return;

	if (toEl.tagName == "A") {
		if (document.body.selectedItem != null && document.body.selectedItem == toEl && ieVersion()==5) {
			toEl.style.color="white";
			toEl.style.background="blue";
		}
		else
			toEl.style.color="blue";
	}
}

function messageTreeOnMouseOut() {
	var fromEl = getReal(window.event.fromElement, "tagName", "A");
	var toEl = getReal(window.event.toElement, "tagName", "A");
    
    if (fromEl == toEl) return;
    
	if (fromEl.tagName == "A") {
		if (document.body.selectedItem != null && document.body.selectedItem == fromEl && ieVersion()==5) {
			fromEl.style.color = "highlighttext";
			fromEl.style.background = "highlight";
		}
		else
			fromEl.style.color = "windowtext";
	}	
}

function makeMessageVisible(el) {
	var tmp = el.parentElement;
	
	while (tmp != null && tmp.className == "item") {
		showItem(tmp.children[0]);
		tmp = tmp.parentElement;
	}
	
//	el.scrollIntoView();
}

function initMessageTreePrime() {
	parent.treeLoaded();
	fixPlusSign();
	fixSize();
	numberOfChildItems();
	
	el = document.all.messageTree;
	el.tree = new Tree(el.children[0]);
	el.tree.add(buildTree(el.children[0]));
	
	scrollDiv.onscroll = new Function("messageHeader.style.marginLeft = -scrollDiv.scrollLeft");
	fixExpandState();
	checkTopUrl();
}

var pluses = new Array();

function fixPlusSign() {
	var index = 0;
	var spans = document.all.tags("span");
	var spansLength = spans.length;
	
	for (var i=0; i<spansLength; i++) {
		if (spans[i].className == "plus")
			pluses[index++] = spans[i];
	}

	var plusesLength = pluses.length;
	for (i=0; i<plusesLength; i++) {
		if (pluses[i].parentElement.children.tags("div").length > 0) {
			pluses[i].innerHTML = plusString;
//			pluses[i].click();
		}
	}
	
	var topItems = messageTree.children[0].children; // Note the <nobr>
	var tpl = topItems.length;
	
	for (var i=0; i<tpl; i++) {
		if (topItems[i].className == "item") {
//			topItems[i].children[0].click();	// Hide the sceond level
		}
	}
}

function fixExpandState() {
	if (parent.tLoaded && parent.toolframe.document.all.toggleExpandCollapseButton.value)
		expandCollapse();
}

function expandCollapse() {
	if (expandedTree) {
		for (var i=0; i<pluses.length; i++) {
			hideItem(pluses[i]);
		}
	}
	else {
		for (var i=0; i<pluses.length; i++) {
			showItem(pluses[i]);
		}
	}

	expandedTree = !expandedTree;
}


function checkTopUrl() {
	if (parent.mLoaded && parent.tLoaded) {

		if (parent.xLoaded) return;		// Prevent external link from being loaded on refresh

		var str = parent.location.href;

		var displayIndex = str.indexOf("action=display");

		if (displayIndex != -1) {
			var args = new Array();
			var as = str.substr(displayIndex + 15).split("&");

			for (var i=0; i<as.length; i++) {
				var tmp = as[i].split("=");
				if (tmp.length != 2) return;
				args[tmp[0]] = tmp[1];
			}
			
			var id = args["id"];
			var group = args["group"];
			
			if (group != null) {
				if (document.body.group != group) {
					parent.oeBar.loadTree(group);
					parent.oeBar.setTimeout("selectRightItem()", 100);
				}
				else {
					var loc = str.substring(0,displayIndex) + "action=preview&group=" + group + "&id=" + id;
					
					loc = loc.replace(/\/\?action/g, "/" + cgiFile + "?action");
					
					var cm = findNode(document.all.messageTree.tree, loc);
				
					if (cm == null) return;
					
					parent.toolframe.toggle(parent.toolframe.document.all.toggleExpandCollapseButton);
					parent.toolframe.makePressed(parent.toolframe.document.all.toggleExpandCollapseButton);
					expandCollapse();
					
					cm.html.children.tags("A")[0].click();
					parent.setXLoaded();
				}
			}	
		}
	}
	else
		window.setTimeout("checkTopUrl()",100); // Busy wait is not nice :-(
}


// Create a tree for ease of use

function Tree(parent) {
	this.parent   = parent;
	this.children = new Array();
	this.nextSibbling = int_nextSibbling;
	this.add      = int_add;
	this.href     = new String();
	this.html     = null;
	this.index    = 0

	var length = 0;
	
	function int_add(t) {
		this.children[length] = t;
		this.children[length].parent = this;
		this.children[length].index = length++;
	}
	
	function int_nextSibbling() {
		if (this.parent != null)
			return this.parent.children[this.index+1];
	}
}

function buildTree(el) {
	var is = new Array();
	var ic = 0;
	var cs = el.children;
	var csl = cs.length;
	
	for (var i=0; i<csl; i++) {
		if (cs[i].className == "item") {
			is[ic++] = cs[i];
		}
	}

	var nTree = new Tree();

	for (var j=0; j<ic; j++) {
		nTree.add(buildTree(is[j]));
		nTree.children[j].href = is[j].all.tags("A")[0].href;
		nTree.children[j].html = is[j];
	}

	return nTree;
}

function nextMessage() {
	var el = document.all.messageTree;
	
	var loc = parent.frames["messageframe"].document.frames[0].location
	
	var cm = findNode(el.tree, loc);

	if (cm == null) return;		// No valid message
	var nm;
	
	if (cm.children.length > 0)
		nm = cm.children[0];
	else
		nm = getNextSibbling(cm);
	
	if (nm != null && nm.href != null) {
		nm.html.all.tags("A")[0].click();
	}
}

function nextThread() {
	el = document.all.messageTree;
	
	var loc = parent.frames["messageframe"].document.frames[0].location;

	var cm = findNode(el.tree, loc);
	if (cm == null) return;		// No valid message

	var nm = getNextTopThread(cm);

	if (nm != null && nm.href != null)
		nm.html.all.tags("A")[0].click();
}

function markTree(inputNode) {
	var el = document.all.messageTree;
	
	var loc = inputNode.parentElement.children.tags("A")[0].href;
	
	var cm = findNode(el.tree, loc);

	if (cm == null) return;		// No valid message
	
	markTree2(cm, inputNode.status);
		
}

function markTree2(node, marked) {
	if (marked) {
		var	nc = node.children;
		if (nc.length > 0) {
			for (var i=0; i < nc.length; i++) {
				var inputNode = nc[i].html.children.tags("INPUT")[0];
				inputNode.status = true;
				addToIdList(inputNode);
				markTree2(nc[i], true);
			}
		}
	}
	else if (node.parent.html != null) {
		var parentInputNode = node.parent.html.children.tags("INPUT")[0];
		parentInputNode.status = false;
		addToIdList(parentInputNode);
		markTree2(node.parent, false);
	}
}

function findNode(t, href) {
	if (t == null) return null;
	if (t.href != null && href != null && t.href == href) {
		return t;
	}
	else {
		for (var i=0; i<t.children.length; i++) {
			var ans = findNode(t.children[i], href);
			if (ans != null)
				return ans;
		}
	}
}

function getNextSibbling(cm) {
	if (cm == null) return;
	var ns = cm.nextSibbling();
	if (ns != null)
		return ns;
	else 
		return getNextSibbling(cm.parent);
}
			
function getNextTopThread(cm) {
	if (cm.parent.href == "")
		return cm.nextSibbling();
	else
		return getNextTopThread(cm.parent);
}

function addToIdList(inputNode) {
	var href = inputNode.parentElement.children.tags("A")[0].href;
	var index = href.indexOf("id=");
	var id = href.substring(index+3,href.length);
	parent.toolframe.idList["_" + id] = inputNode.status;
	parent.toolframe.checkDeleteButtonStatus();
}

function hideItem(plusEl) {
		var el = plusEl.parentElement;
		
		var children = el.children;
		var childrenLength = children.length;
		
		for (var i=0; i<childrenLength; i++) {
			var child = children.item(i);
			if (child.className == "item") {
				child.style.display = "none";
				plusEl.innerHTML = plusString;
			}
		}
}

function showItem(plusEl) {
		var el = plusEl.parentElement;
		
		var children = el.children;
		var childrenLength = children.length;
		
		for (var i=0; i<childrenLength; i++) {
			var child = children.item(i);
			if (child.className == "item") {
				child.style.display = "block";
				plusEl.innerHTML = minusString;
			}
		}
}


// These two functions describe how the items should look when highlighted

function highLight(el) {
	if (ieVersion() == 5) {
		el.style.background = "highlight";
		el.style.color = "highlighttext";
	}
}

function unHighLight(el) {
	if (ieVersion() == 5) {
		el.style.background = ""; //"window";
		el.style.color = "windowtext";
	}
}

function numberOfChildItems() {
	var itemDivs = new Array();
	var index = 0;

	var divs = document.all.tags("DIV");
	var divsLength = divs.length;

	for (var i=0; i<divsLength; i++) {
		if (divs[i].className == "item")
			itemDivs[index++] = divs[i];
	}
	
	var itemsLength = itemDivs.length;
	for (i=0; i<itemsLength; i++) {
		itemChildren = getChildren(itemDivs[i]);

		var atag = itemDivs[i].children.tags("A")[0]
		var subjectSpan = atag.children[0];
		var nameSpan = atag.children[1];
		var dateSpan = atag.children[2];

		atag.title = subjectSpan.innerText + "\n" + nameSpan.innerText + "\n" + dateSpan.innerText;

		if (itemChildren > 0 && showNumberOfReplys) {

			subjectSpan.innerHTML += replysStartTag + itemChildren + replysEndTag;
		}
	}
}

function getChildren(el) {
	var l = el.children.tags("DIV").length;

	if (l == 0)
		return 0;
	else {
		var ec = el.children.tags("DIV");
		var ecl = ec.length
		for (var i=0; i < ecl; i++) {
			l += getChildren(ec[i]);
		}
		return l;
	}
}

function fixSubPadding(depth) {
	var str2, val;
	
	var width = 300;

	for (var i=0; i < depth; i++) {
		str2 = "";
		val  = 0;
		for (var j=0; j < i; j++) {
			str2 += ".item "
			val += 18;
		}
		document.styleSheets[0].addRule(str2 + ".plus", "width: " + val);
		document.styleSheets[0].addRule(str2 + ".subject", "width: " + (width - val));
	}
}

function fixScrollDivSize() {
//	alert(document.body.clientHeight - messageHeader.offsetHeight)
	document.styleSheets[0].addRule("#scrollDiv", "height: " + (document.body.clientHeight - messageHeader.offsetHeight));
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////
// treeSort.js	This is a rewriting of the tableSort script available at WebFX
///////////////////////////////////////////////////////////////////////////////////////////////////////////////
var ie5 = (document.all && document.getElementsByTagName);

if (ie5)
	initSortTree();

var arrowUp, arrowDown;

function initSortTree() {
// Note that the class arrow should be defined in the css
	arrowUp = document.createElement("SPAN");
	var tn = document.createTextNode("6");
	arrowUp.appendChild(tn);
	arrowUp.className = "arrow";

	arrowDown = document.createElement("SPAN");
	var tn = document.createTextNode("5");
	arrowDown.appendChild(tn);
	arrowDown.className = "arrow";
}


function sortBy(type) {
	if (ie5) {
		if (document.all.startArrow != null) {
			sentHeader._descending = true;
			startArrow.parentNode.removeChild(startArrow);
		}
		var el = document.getElementById(type + "Header");
		sortTree(el, messageTree.childNodes[0], type);
	}
}

function sortByColumn(srcEl, type, bDesc) {
	sortTree(srcEl, messageTree, type, bDesc);
}

function sortTree(srcEl, treeNode, type, bDesc) {
	var el = srcEl;
	
	if (el == null)
		return;

	if (bDesc != null)
		el._descending = bDesc;
	else
		if (el._descending)	// catch the null
			el._descending = false;
		else
			el._descending = true;
		
	if (treeNode.arrow != null) {
		if (treeNode.arrow.parentNode != el) {
			treeNode.arrow.parentNode._descending = null;	//reset sort order		
		}
		treeNode.arrow.parentNode.removeChild(treeNode.arrow);
	}
	
	if (el._descending)
		treeNode.arrow = arrowDown.cloneNode(true);
	else
		treeNode.arrow = arrowUp.cloneNode(true);
		
	el.appendChild(treeNode.arrow);

	var trs = treeNode.childNodes;
	var a = new Array();
	
	for (var i=0; i<trs.length-1; i++) {	// First is empty
		a[i] = trs[i+1];
	}
	
	a.sort(compareByColumn(type,el._descending));
	
	for (var i=0; i<a.length; i++) {
		treeNode.appendChild(a[i]);
	}
}

function compareByColumn(type, bDescending) {
	var t = type;
	var d = bDescending;

	function _compareSent(n1,n2) {
		if (n1.date > n2.date)
			return (d) ? -1 : +1;
		else if (n1.date < n2.date)
			return (d) ? +1 : -1;
		else 
			return 0;
	}

	function _compareSubject(n1,n2) {
		if (n1.innerText.toLowerCase() < n2.innerText.toLowerCase())
			return (d) ? -1 : +1;
		else if (n1.innerText.toLowerCase() > n2.innerText.toLowerCase())
			return (d) ? +1 : -1;
		else 
			return 0;
	}
	
	function _compareFrom(n1,n2) {
		if (n1.childNodes[1].childNodes[1].innerText.toLowerCase() < n2.childNodes[1].childNodes[1].innerText.toLowerCase())
			return (d) ? -1 : +1;
		else if (n1.childNodes[1].childNodes[1].innerText.toLowerCase() > n2.childNodes[1].childNodes[1].innerText.toLowerCase())
			return (d) ? +1 : -1;
		else 
			return 0;
	}

	function _compareFromAdmin(n1,n2) {
		if (n1.childNodes[2].childNodes[1].innerText.toLowerCase() < n2.childNodes[2].childNodes[1].innerText.toLowerCase())
			return (d) ? -1 : +1;
		else if (n1.childNodes[2].childNodes[1].innerText.toLowerCase() > n2.childNodes[2].childNodes[1].innerText.toLowerCase())
			return (d) ? +1 : -1;
		else 
			return 0;
	}
	switch (type) {
		case "sent":
		return _compareSent;
		
		case "subject":
		return _compareSubject;
		
		case "from":
		if (document.body.password != null)
			return _compareFromAdmin;
		else
			return _compareFrom;
	}
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////
// end treeSort.js
///////////////////////////////////////////////////////////////////////////////////////////////////////////////